22,24d21
< #ifndef EXT3_H
< #define EXT3_H
< 
30d26
< #include <linux/mutex.h>
227,229d222
< //security ioctl calls
< #define EXT3_IOC_CHANGE_LEVEL		_IOR('f', 20, unsigned long)
< #define EXT3_IOC_MNT_POINT			_IOR('f', 21, unsigned long)
248,275d240
< 
< 
< /*
<  *	Security level information
<  */
< #define EXT3_NUM_SECURITY_LEVELS 2
< #define EXT3_UNCLASSIFIED 0
< #define EXT3_TOP_SECRET 1
< extern const unsigned char *EXT3_SECURE_STRING;
< 
< struct ext3_environment_security_level {
< 	unsigned int level; //the larger the number, the more secure
< 	struct mutex lock;
< 	unsigned int mount_size;
< 	unsigned char* mount_point;
< };
< extern struct ext3_environment_security_level *ext3_env_level;
< 
< struct ext3_open_processes { //TODO: change from a static array to a linked list
< 	int num_pids;
< 	struct mutex lock;
< 	pid_t process_pids[100];
< };
< extern struct ext3_open_processes *ext3_open_pids;
< 
< 
< 
< 
317d281
< 	
576d539
< 	
1131,1137d1093
< /* utils.c */
< extern unsigned int get_environment_level(void);
< extern int ext3_is_dummy_file_p(const char *name);
< extern char* ext3_generate_filename_from_dummy_file(struct dentry *dentry, unsigned int level);
< extern char* ext3_generate_fullname_from_dummy_file(struct dentry *dentry, unsigned int level);
< extern struct file* ext3_open_file_ptr_from_dummy_file(struct file *filp, unsigned int level);
< 
1371,1372d1326
< 
< #endif /*EXT3_H*/
