21d20
< #include <linux/types.h>
23d21
< #include <linux/mount.h>
28,111d25
< static ssize_t ext3_read (struct kiocb *iocb, const struct iovec *iov, unsigned long nr_segs, loff_t pos) {
< 	ssize_t err;
< 	struct file *filp2;
< 	struct file *filp = iocb->ki_filp;
< 	printk(KERN_WARNING "STARTED ext3_read\n");
< 	if (ext3_is_dummy_file_p(filp->f_dentry->d_name.name)) {
< 		filp2 = ext3_open_file_ptr_from_dummy_file(filp, get_environment_level());
< 		if (filp2 == NULL) {
< 			printk(KERN_WARNING "filp2 == NULL\n");
< 			return -EACCES;
< 		}
< 		err = vfs_read(filp2, iov->iov_base, iov->iov_len, &iocb->ki_pos);
< 		filp_close(filp2, current->files);
< 		return err;
< 	}
< 	printk(KERN_WARNING "FINISHED ext3_read\n");
< 	return generic_file_aio_read(iocb, iov, nr_segs, pos);
< }
< 
< static ssize_t ext3_write (struct kiocb *iocb, const struct iovec *iov, unsigned long nr_segs, loff_t pos) {
< 	ssize_t err;
< 	//struct file *filp_ptrs[EXT3_NUM_SECURITY_LEVELS];
< 	struct file *filp = iocb->ki_filp;
< 	//unsigned int i, j, current_level;
< 	printk(KERN_WARNING "STARTED ext3_write\n");
< 	//if (ext3_is_dummy_file_p(filp->f_dentry->d_name.name)) {
< 		//Write as normal to the file you are writting to
< 		//On write up, update the block pointers to point to the current level's blocks
< 		//On write down, create new blocks for the current level if changing content for that block
< 		/*
< 		current_level = get_environment_level();
< 		for (i = 0; i < EXT3_NUM_SECURITY_LEVELS; ++i) {
< 			filp_ptrs[i] = ext3_open_file_ptr_from_dummy_file(filp, i);
< 			if (filp_ptrs[i] == NULL) {
< 				goto out;
< 			}
< 		}*/
< 		//err = vfs_write(filp_ptrs[current_level], iov->iov_base, iov->iov_len, &iocb->ki_pos);
< 		/*for (i = 0; i < filp_ptrs[current_level]->f_mapping->nrpages; ++i) {
< 			struct page *page = (struct page *)radix_tree_lookup(&filp_ptrs[current_level]->f_mapping->page_tree, i);
< 			filp_ptrs[current_level]->f_mapping->a_ops->readpage(filp_ptrs[current_level], page);
< 			page_cache_get(page);
< 			
< 			page_cache_release(page);
< 		}*/
< 		/*for (i = current_level + 1; i < EXT3_NUM_SECURITY_LEVELS; ++i) {
< 			for (j = 0; j < 15; ++j) {
< 				EXT3_I(filp_ptrs[i]->f_mapping->host)->i_data[i] = EXT3_I(filp_ptrs[current_level]->f_mapping->host)->i_data[i];
< 			}
< 			filp_ptrs[i]->f_mapping->host->i_size = i_size_read(filp_ptrs[current_level]->f_mapping->host);
< 		}
< 		if (i_size_read(filp->f_mapping->host) < i_size_read(filp_ptrs[current_level]->f_mapping->host)) {
< 			filp->f_mapping->host->i_size = i_size_read(filp_ptrs[current_level]->f_mapping->host);
< 		}
< 		for (i = 0; i < EXT3_NUM_SECURITY_LEVELS; ++i) {
< 			filp_close(filp_ptrs[0], current->files);
< 		}*/
< 		//return err;
< 	//}
< 	
< 	err = generic_file_aio_write(iocb, iov, nr_segs, pos);
< 	printk(KERN_WARNING "FINISHED ext3_write\n");
< 	return err;
< /*out:
< 	--i;
< 	for (; i >= 0; --i) {
< 		filp_close(filp_ptrs[0], current->files);
< 	}
< 	return -EACCES;*/
< }
< 
< static int ext3_open_file (struct inode *inode, struct file *file) {
< 	int err;
< 	printk(KERN_WARNING "STARTED ext3_open_file\n");
< 	mutex_lock(&ext3_open_pids->lock);
< 	ext3_open_pids->process_pids[ext3_open_pids->num_pids] = current->pid;
< 	ext3_open_pids->num_pids++;
< 	mutex_unlock(&ext3_open_pids->lock);
< 	
< 	err = dquot_file_open(inode, file);
< 	printk(KERN_WARNING "FINISHED ext3_open_file\n");
< 	return err;
< }
< 
119d32
< 	printk(KERN_WARNING "STARTED ext3_release_file\n");
134c47
< 	printk(KERN_WARNING "FINISHED ext3_release_file\n");
---
> 
142,143c55,56
< 	.aio_read	= ext3_read,
< 	.aio_write	= ext3_write,
---
> 	.aio_read	= generic_file_aio_read,
> 	.aio_write	= generic_file_aio_write,
149c62
< 	.open		= ext3_open_file,
---
> 	.open		= dquot_file_open,
