1244c1244
< static int ext3_write_begin(struct file *filp, struct address_space *mapping,
---
> static int ext3_write_begin(struct file *file, struct address_space *mapping,
1248d1247
< 	struct file *filp_ptrs[EXT3_NUM_SECURITY_LEVELS];
1256d1254
< 	unsigned int i, j, current_level;
1261,1262d1258
< 	printk(KERN_WARNING "STARTED ext3_write_begin\n");
< 
1265,1312d1260
< 	if (ext3_is_dummy_file_p(filp->f_dentry->d_name.name)) {
< 		
< 		//grab current context level
< 		current_level = get_environment_level();
< 		
< 		//open files
< 		for (i = 0; i < EXT3_NUM_SECURITY_LEVELS; ++i) {
< 			filp_ptrs[i] = ext3_open_file_ptr_from_dummy_file(filp, i);
< 			if (filp_ptrs[i] == NULL) {
< 				goto opens_failed_out;
< 			}
< 		}
< 		
< 		//if pointing to the same block as a lower level, grab a new block
< 		//if (current_level > 0 && filp_ptrs[current_level - 1] points to the same block as filp_ptrs[current_level]) {
< 			//insert block
< 			/*index = pos >> PAGE_CACHE_SHIFT;
< 			++index;
< 			from = pos & (PAGE_CACHE_SIZE - 1);
< 			to = from + len;*/
< 		//}
< 		
< 		//perform write on the correct context
< 		ret = ext3_write_begin(filp_ptrs[current_level], filp_ptrs[current_level]->f_mapping, pos, len, flags, pagep, fsdata);
< 		
< 		//update levels greater than context if new block is added
< 		for (i = current_level + 1; i < EXT3_NUM_SECURITY_LEVELS; ++i) {
< 			for (j = 0; j < 15; ++j) {
< 				//update pointers if added new blocks
< 			}
< 			if (i_size_read(filp_ptrs[i]->f_mapping->host) < i_size_read(filp_ptrs[current_level]->f_mapping->host)) {
< 				filp_ptrs[i]->f_mapping->host->i_size = i_size_read(filp_ptrs[current_level]->f_mapping->host);
< 			}
< 		}
< 		
< 		//update dummy file
< 		if (i_size_read(filp->f_mapping->host) < i_size_read(filp_ptrs[current_level]->f_mapping->host)) {
< 			filp->f_mapping->host->i_size = i_size_read(filp_ptrs[current_level]->f_mapping->host);
< 		}
< 		
< 		//close files
< 		for (i = 0; i < EXT3_NUM_SECURITY_LEVELS; ++i) {
< 			filp_close(filp_ptrs[0], current->files);
< 		}
< 		
< 		return ret;
< 	}
< 
1321d1268
< 	
1331d1277
< 	
1333d1278
< 	
1363d1307
< 	printk(KERN_WARNING "FINISHED ext3_write_begin\n");
1365,1370d1308
< opens_failed_out:
< 	--i;
< 	for (; i >= 0; --i) {
< 		filp_close(filp_ptrs[0], current->files);
< 	}
< 	return -EACCES;
1438,1439d1375
< 	printk(KERN_WARNING "STARTED ext3_ordered_write_end\n");
< 
1464,1466d1399
< 	
< 	printk(KERN_WARNING "FINISHED ext3_ordered_write_end\n");
< 		
3249c3182
< 	
---
> 
