#!/usr/bin/python
import subprocess

def SecModuleOutput():

    # Get current wireless AP
    p2 = subprocess.Popen(['iwconfig', 'wlan0'], stdout=subprocess.PIPE)
    out_config, err2 = p2.communicate()
    current_ap = [line.split(':')[1].strip('"') for line in out_config.split() if 'ESSID' in line][0]

    # Get cells for all available APs
    p1 = subprocess.Popen(['iwlist', 'wlan0', 'scan'], stdout=subprocess.PIPE)
    out_list, err = p1.communicate()
    cells = out_list.split('Cell')

    # Cross reference AP ESSID
    ap_stats = [cell for cell in cells if current_ap in cell][0]

    # If statements checking out encryption?, type?, etc., return value
    calculator = 'wirelessCalc'
    if 'Encryption:off' in ap_stats:
        return [calculator, 0]
    elif 'WPA2' in ap_stats:
        return [calculator, 1]
    else:
        return [calculator, 0]


# For testing
if __name__ == '__main__':
    print SecModuleOutput()[1]

