#include <stdio.h> 
#include <unistd.h>
#include <sys/ioctl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#define EXT3_IOC_MNT_POINT			_IOR('f', 21, unsigned long)
#define WAIT_TIME_IN_HUND_MS 4
#define US_TO_MS 1000

int main(int argc, char* argv[]) {
	int ret;
	unsigned int usecs = (WAIT_TIME_IN_HUND_MS * 100 * US_TO_MS);
	unsigned long mount_array[2];
	int fd = open(argv[1], O_RDONLY);
	
	mount_array[0] = (unsigned long)sizeof(argv[1]);
	mount_array[1] = (unsigned long) argv[1];
	
	ret = ioctl(fd, EXT3_IOC_MNT_POINT, (unsigned long)mount_array);

	close(fd);
	return ret;
}
