#!/usr/bin/python

######################################################################
# The module_Output_Set class holds the module_Outputs of all of the
# modules being used by the context monitor.
######################################################################


class moduleOutputSet:

  def __init__(self):
    self.modOutputArray = []
    self.sizeArray = 0

  def addModuleOutput(self, modOutput):
    self.modOutputArray.append(modOutput)
    self.sizeArray = self.sizeArray + 1

  def subModuleOutput(self, index):
    self.modOutputArray.pop(index)
    self.sizeArray = self.sizeArray - 1

  def getModuleOutput(self, index):
    return self.modOutputArray[index]

  def getSize(self):
    return self.sizeArray

"""
def main():
  testSet = moduleOutputSet()
  testModOut = moduleOutputClass.moduleOutput("2.1.1")
  print testModOut.getSecInfo()
  testSet.addModuleOutput(testModOut)
  print testSet.getSizeArray()
  x = testSet.getModuleOutput(0)
  print x.getSecInfo()
  testSet.subModuleOutput(0)
  print testSet.getSizeArray()

if __name__=='__main__':
  main()
"""
